diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ampdu-tag.h ns-3.34/src/wifi/model/ampdu-tag.h
--- ns-3.33/src/wifi/model/ampdu-tag.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ampdu-tag.h	2021-07-14 10:31:07.000000000 -0700
@@ -41,7 +41,12 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
+
+  TypeId GetInstanceTypeId (void) const override;
+  void Serialize (TagBuffer i) const override;
+  void Deserialize (TagBuffer i) override;
+  uint32_t GetSerializedSize () const override;
+  void Print (std::ostream &os) const override;
 
   /**
    * Create a AmpduTag with the default =0 no A-MPDU
@@ -60,11 +65,6 @@
    */
   void SetRemainingAmpduDuration (Time duration);
 
-  void Serialize (TagBuffer i) const;
-  void Deserialize (TagBuffer i);
-  uint32_t GetSerializedSize () const;
-  void Print (std::ostream &os) const;
-
   /**
    * \return the remaining number of MPDUs in an A-MPDU
    *
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/amsdu-subframe-header.h ns-3.34/src/wifi/model/amsdu-subframe-header.h
--- ns-3.33/src/wifi/model/amsdu-subframe-header.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/amsdu-subframe-header.h	2021-07-14 10:31:07.000000000 -0700
@@ -41,11 +41,12 @@
    * \return the object TypeId
    */
   static TypeId GetTypeId (void);
-  TypeId GetInstanceTypeId (void) const;
-  void Print (std::ostream &os) const;
-  uint32_t GetSerializedSize (void) const;
-  void Serialize (Buffer::Iterator start) const;
-  uint32_t Deserialize (Buffer::Iterator start);
+
+  TypeId GetInstanceTypeId (void) const override;
+  void Print (std::ostream &os) const override;
+  uint32_t GetSerializedSize (void) const override;
+  void Serialize (Buffer::Iterator start) const override;
+  uint32_t Deserialize (Buffer::Iterator start) override;
 
   /**
    * Set destination address function
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/ap-wifi-mac.cc ns-3.34/src/wifi/model/ap-wifi-mac.cc
--- ns-3.33/src/wifi/model/ap-wifi-mac.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/wifi/model/ap-wifi-mac.cc	2021-07-14 10:31:07.000000000 -0700
@@ -27,7 +27,7 @@
 #include "ns3/string.h"
 #include "ns3/random-variable-stream.h"
 #include "ap-wifi-mac.h"
-#include "mac-low.h"
+#include "channel-access-manager.h"
 #include "mac-tx-middle.h"
 #include "mac-rx-middle.h"
 #include "mgt-headers.h"
@@ -35,8 +35,8 @@
 #include "amsdu-subframe-header.h"
 #include "wifi-phy.h"
 #include "wifi-net-device.h"
-#include "ht-configuration.h"
-#include "he-configuration.h"
+#include "ns3/ht-configuration.h"
+#include "ns3/he-configuration.h"
 
 namespace ns3 {
 
@@ -48,7 +48,7 @@
 ApWifiMac::GetTypeId (void)
 {
   static TypeId tid = TypeId ("ns3::ApWifiMac")
-    .SetParent<InfrastructureWifiMac> ()
+    .SetParent<RegularWifiMac> ()
     .SetGroupName ("Wifi")
     .AddConstructor<ApWifiMac> ()
     .AddAttribute ("BeaconInterval",
@@ -57,11 +57,6 @@
                    MakeTimeAccessor (&ApWifiMac::GetBeaconInterval,
                                      &ApWifiMac::SetBeaconInterval),
                    MakeTimeChecker ())
-    .AddAttribute ("CfpMaxDuration", "The maximum size of the CFP (used when AP supports PCF)",
-                   TimeValue (MicroSeconds (51200)),
-                   MakeTimeAccessor (&ApWifiMac::GetCfpMaxDuration,
-                                     &ApWifiMac::SetCfpMaxDuration),
-                   MakeTimeChecker ())
     .AddAttribute ("BeaconJitter",
                    "A uniform random variable to cause the initial beacon starting time (after simulation time 0) "
                    "to be distributed between 0 and the BeaconInterval.",
@@ -83,37 +78,47 @@
                    BooleanValue (true),
                    MakeBooleanAccessor (&ApWifiMac::m_enableNonErpProtection),
                    MakeBooleanChecker ())
+    .AddAttribute ("BsrLifetime",
+                   "Lifetime of Buffer Status Reports received from stations.",
+                   TimeValue (MilliSeconds (20)),
+                   MakeTimeAccessor (&ApWifiMac::m_bsrLifetime),
+                   MakeTimeChecker ())
+    .AddTraceSource ("AssociatedSta",
+                     "A station associated with this access point.",
+                     MakeTraceSourceAccessor (&ApWifiMac::m_assocLogger),
+                     "ns3::ApWifiMac::AssociationCallback")
+    .AddTraceSource ("DeAssociatedSta",
+                     "A station lost association with this access point.",
+                     MakeTraceSourceAccessor (&ApWifiMac::m_deAssocLogger),
+                     "ns3::ApWifiMac::AssociationCallback")
   ;
   return tid;
 }
 
 ApWifiMac::ApWifiMac ()
-  : m_enableBeaconGeneration (false)
+  : m_enableBeaconGeneration (false),
+    m_numNonErpStations (0),
+    m_numNonHtStations (0),
+    m_shortSlotTimeEnabled (false),
+    m_shortPreambleEnabled (false)
 {
   NS_LOG_FUNCTION (this);
   m_beaconTxop = CreateObject<Txop> ();
   m_beaconTxop->SetAifsn (1);
   m_beaconTxop->SetMinCw (0);
   m_beaconTxop->SetMaxCw (0);
-  m_beaconTxop->SetMacLow (m_low);
   m_beaconTxop->SetChannelAccessManager (m_channelAccessManager);
   m_beaconTxop->SetTxMiddle (m_txMiddle);
-  m_beaconTxop->SetTxOkCallback (MakeCallback (&ApWifiMac::TxOk, this));
-  m_rxMiddle->SetPcfCallback (MakeCallback (&ApWifiMac::SendNextCfFrame, this));
 
   //Let the lower layers know that we are acting as an AP.
   SetTypeOfStation (AP);
-
-  m_itCfPollingList = m_cfPollingList.begin ();
 }
 
 ApWifiMac::~ApWifiMac ()
 {
   NS_LOG_FUNCTION (this);
   m_staList.clear ();
-  m_nonErpStations.clear ();
-  m_nonHtStations.clear ();
-  m_cfPollingList.clear ();
+  m_addressIdMap.clear ();
 }
 
 void
@@ -124,7 +129,6 @@
   m_beaconTxop = 0;
   m_enableBeaconGeneration = false;
   m_beaconEvent.Cancel ();
-  m_cfpEvent.Cancel ();
   RegularWifiMac::DoDispose ();
 }
 
@@ -157,14 +161,7 @@
 ApWifiMac::GetBeaconInterval (void) const
 {
   NS_LOG_FUNCTION (this);
-  return m_low->GetBeaconInterval ();
-}
-
-Time
-ApWifiMac::GetCfpMaxDuration (void) const
-{
-  NS_LOG_FUNCTION (this);
-  return m_low->GetCfpMaxDuration ();
+  return m_beaconInterval;
 }
 
 void
@@ -173,7 +170,6 @@
   NS_LOG_FUNCTION (this << stationManager);
   m_beaconTxop->SetWifiRemoteStationManager (stationManager);
   RegularWifiMac::SetWifiRemoteStationManager (stationManager);
-  m_stationManager->SetPcfSupported (GetPcfSupported ());
 }
 
 void
@@ -200,18 +196,7 @@
     {
       NS_FATAL_ERROR ("beacon interval should be smaller then or equal to 65535 * 1024us (802.11 time unit)");
     }
-  m_low->SetBeaconInterval (interval);
-}
-
-void
-ApWifiMac::SetCfpMaxDuration (Time duration)
-{
-  NS_LOG_FUNCTION (this << duration);
-  if ((duration.GetMicroSeconds () % 1024) != 0)
-    {
-      NS_LOG_WARN ("CFP max duration should be multiple of 1024us (802.11 time unit)");
-    }
-  m_low->SetCfpMaxDuration (duration);
+  m_beaconInterval = interval;
 }
 
 int64_t
@@ -222,71 +207,62 @@
   return 1;
 }
 
-bool
-ApWifiMac::GetShortSlotTimeEnabled (void) const
+void
+ApWifiMac::UpdateShortSlotTimeEnabled (void)
 {
-  if (m_nonErpStations.size () != 0)
-    {
-      return false;
-    }
-  if (GetErpSupported () && GetShortSlotTimeSupported ())
+  NS_LOG_FUNCTION (this);
+  if (GetErpSupported () && GetShortSlotTimeSupported () && (m_numNonErpStations == 0))
     {
-      for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+      for (const auto& sta : m_staList)
         {
-          if (!m_stationManager->GetShortSlotTimeSupported (i->second))
+          if (!m_stationManager->GetShortSlotTimeSupported (sta.second))
             {
-              return false;
+              m_shortSlotTimeEnabled = false;
+              return;
             }
         }
-      return true;
+      m_shortSlotTimeEnabled = true;
+    }
+  else
+    {
+      m_shortSlotTimeEnabled = false;
     }
-  return false;
 }
 
-bool
-ApWifiMac::GetShortPreambleEnabled (void) const
+void
+ApWifiMac::UpdateShortPreambleEnabled (void)
 {
+  NS_LOG_FUNCTION (this);
   if (GetErpSupported () && m_phy->GetShortPhyPreambleSupported ())
     {
-      for (std::list<Mac48Address>::const_iterator i = m_nonErpStations.begin (); i != m_nonErpStations.end (); i++)
+      for (const auto& sta : m_staList)
         {
-          if (!m_stationManager->GetShortPreambleSupported (*i))
+          if (!m_stationManager->GetErpOfdmSupported (sta.second) ||
+              !m_stationManager->GetShortPreambleSupported (sta.second))
             {
-              return false;
+              m_shortPreambleEnabled = false;
+              return;
             }
         }
-      return true;
+      m_shortPreambleEnabled = true;
     }
-  return false;
-}
-
-bool
-ApWifiMac::IsNonGfHtStasPresent (void) const
-{
-  bool isNonGfHtStasPresent = false;
-  for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+  else
     {
-      if (!m_stationManager->GetGreenfieldSupported (i->second))
-        {
-          isNonGfHtStasPresent = true;
-          break;
-        }
+      m_shortPreambleEnabled = false;
     }
-  m_stationManager->SetUseGreenfieldProtection (isNonGfHtStasPresent);
-  return isNonGfHtStasPresent;
 }
 
 uint16_t
 ApWifiMac::GetVhtOperationalChannelWidth (void) const
 {
   uint16_t channelWidth = m_phy->GetChannelWidth ();
-  for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+  for (const auto& sta : m_staList)
     {
-      if (m_stationManager->GetVhtSupported (i->second))
+      if (m_stationManager->GetVhtSupported (sta.second))
         {
-          if (m_stationManager->GetChannelWidthSupported (i->second) < channelWidth)
+          if (m_stationManager->GetChannelWidthSupported (sta.second) < channelWidth)
             {
-              channelWidth = m_stationManager->GetChannelWidthSupported (i->second);
+              channelWidth = m_stationManager->GetChannelWidthSupported (sta.second);
             }
         }
     }
@@ -390,7 +366,7 @@
   //We're sending this packet with a from address that is our own. We
   //get that address from the lower MAC and make use of the
   //from-spoofing Enqueue() method to avoid duplicated code.
-  Enqueue (packet, to, m_low->GetAddress ());
+  Enqueue (packet, to, GetAddress ());
 }
 
 bool
@@ -407,9 +383,8 @@
   SupportedRates rates;
   //Send the set of supported rates and make sure that we indicate
   //the Basic Rate set in this set of supported rates.
-  for (uint8_t i = 0; i < m_phy->GetNModes (); i++)
+  for (const auto & mode : m_phy->GetModeList ())
     {
-      WifiMode mode = m_phy->GetMode (i);
       uint64_t modeDataRate = mode.GetDataRate (m_phy->GetChannelWidth ());
       NS_LOG_DEBUG ("Adding supported rate of " << modeDataRate);
       rates.AddSupportedRate (modeDataRate);
@@ -436,9 +411,9 @@
   //Also the standard mentioned that at least 1 element should be included in the SupportedRates the rest can be in the ExtendedSupportedRates
   if (GetHtSupported ())
     {
-      for (uint8_t i = 0; i < m_phy->GetNBssMembershipSelectors (); i++)
+      for (const auto & selector : m_phy->GetBssMembershipSelectorList ())
         {
-          rates.AddBssMembershipSelectorRate (m_phy->GetBssMembershipSelector (i));
+          rates.AddBssMembershipSelectorRate (selector);
         }
     }
   return rates;
@@ -462,13 +437,9 @@
 {
   NS_LOG_FUNCTION (this);
   CapabilityInformation capabilities;
-  capabilities.SetShortPreamble (GetShortPreambleEnabled ());
-  capabilities.SetShortSlotTime (GetShortSlotTimeEnabled ());
+  capabilities.SetShortPreamble (m_shortPreambleEnabled);
+  capabilities.SetShortSlotTime (m_shortSlotTimeEnabled);
   capabilities.SetEss ();
-  if (GetPcfSupported ())
-    {
-      capabilities.SetCfPollable ();
-    }
   return capabilities;
 }
 
@@ -480,9 +451,9 @@
   information.SetErpSupported (1);
   if (GetErpSupported ())
     {
-      information.SetNonErpPresent (!m_nonErpStations.empty ());
+      information.SetNonErpPresent (m_numNonErpStations > 0);
       information.SetUseProtection (GetUseNonErpProtection ());
-      if (GetShortPreambleEnabled ())
+      if (m_shortPreambleEnabled)
         {
           information.SetBarkerPreambleMode (0);
         }
@@ -542,21 +513,6 @@
   return edcaParameters;
 }
 
-CfParameterSet
-ApWifiMac::GetCfParameterSet (void) const
-{
-  CfParameterSet cfParameterSet;
-  if (GetPcfSupported () && !m_cfPollingList.empty ())
-    {
-      cfParameterSet.SetPcfSupported (1);
-      cfParameterSet.SetCFPCount (0);
-      cfParameterSet.SetCFPPeriod (1);
-      cfParameterSet.SetCFPMaxDurationUs (GetCfpMaxDuration ().GetMicroSeconds ());
-      cfParameterSet.SetCFPDurRemainingUs (GetCfpMaxDuration ().GetMicroSeconds ());
-    }
-  return cfParameterSet;
-}
-
 HtOperation
 ApWifiMac::GetHtOperation (void) const
 {
@@ -567,13 +523,13 @@
       operation.SetHtSupported (1);
       operation.SetPrimaryChannel (m_phy->GetChannelNumber ());
       operation.SetRifsMode (false);
-      operation.SetNonGfHtStasPresent (IsNonGfHtStasPresent ());
+      operation.SetNonGfHtStasPresent (true);
       if (m_phy->GetChannelWidth () > 20)
         {
           operation.SetSecondaryChannelOffset (1);
           operation.SetStaChannelWidth (1);
         }
-      if (m_nonHtStations.empty ())
+      if (m_numNonHtStations == 0)
         {
           operation.SetHtProtection (NO_PROTECTION);
         }
@@ -582,13 +538,8 @@
           operation.SetHtProtection (MIXED_MODE_PROTECTION);
         }
       uint64_t maxSupportedRate = 0; //in bit/s
-      for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+      for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_HT))
         {
-          WifiMode mcs = m_phy->GetMcs (i);
-          if (mcs.GetModulationClass () != WIFI_MOD_CLASS_HT)
-            {
-              continue;
-            }
           uint8_t nss = (mcs.GetMcsValue () / 8) + 1;
           NS_ASSERT (nss > 0 && nss < 5);
           uint64_t dataRate = mcs.GetDataRate (m_phy->GetChannelWidth (), GetHtConfiguration ()->GetShortGuardIntervalSupported () ? 400 : 800, nss);
@@ -599,22 +550,21 @@
             }
         }
       uint8_t maxSpatialStream = m_phy->GetMaxSupportedTxSpatialStreams ();
-      uint8_t nMcs = m_phy->GetNMcs ();
-      for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+      auto mcsList = m_phy->GetMcsList (WIFI_MOD_CLASS_HT);
+      uint8_t nMcs = mcsList.size ();
+      for (const auto& sta : m_staList)
         {
-          if (m_stationManager->GetHtSupported (i->second))
+          if (m_stationManager->GetHtSupported (sta.second))
             {
               uint64_t maxSupportedRateByHtSta = 0; //in bit/s
-              for (uint8_t j = 0; j < (std::min (nMcs, m_stationManager->GetNMcsSupported (i->second))); j++)
+              auto itMcs = mcsList.begin ();
+              for (uint8_t j = 0; j < (std::min (nMcs, m_stationManager->GetNMcsSupported (sta.second))); j++)
                 {
-                  WifiMode mcs = m_phy->GetMcs (j);
-                  if (mcs.GetModulationClass () != WIFI_MOD_CLASS_HT)
-                    {
-                      continue;
-                    }
+                  WifiMode mcs = *itMcs++;
                   uint8_t nss = (mcs.GetMcsValue () / 8) + 1;
                   NS_ASSERT (nss > 0 && nss < 5);
-                  uint64_t dataRate = mcs.GetDataRate (m_stationManager->GetChannelWidthSupported (i->second), m_stationManager->GetShortGuardIntervalSupported (i->second) ? 400 : 800, nss);
+                  uint64_t dataRate = mcs.GetDataRate (m_stationManager->GetChannelWidthSupported (sta.second),
+                                                       m_stationManager->GetShortGuardIntervalSupported (sta.second) ? 400 : 800, nss);
                   if (dataRate > maxSupportedRateByHtSta)
                     {
                       maxSupportedRateByHtSta = dataRate;
@@ -624,13 +574,13 @@
                 {
                   maxSupportedRate = maxSupportedRateByHtSta;
                 }
-              if (m_stationManager->GetNMcsSupported (i->second) < nMcs)
+              if (m_stationManager->GetNMcsSupported (sta.second) < nMcs)
                 {
-                  nMcs = m_stationManager->GetNMcsSupported (i->second);
+                  nMcs = m_stationManager->GetNMcsSupported (sta.second);
                 }
-              if (m_stationManager->GetNumberOfSupportedStreams (i->second) < maxSpatialStream)
+              if (m_stationManager->GetNumberOfSupportedStreams (sta.second) < maxSpatialStream)
                 {
-                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (i->second);
+                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (sta.second);
                 }
             }
         }
@@ -674,13 +624,13 @@
           operation.SetChannelWidth (0);
         }
       uint8_t maxSpatialStream = m_phy->GetMaxSupportedRxSpatialStreams ();
-      for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+      for (const auto& sta : m_staList)
         {
-          if (m_stationManager->GetVhtSupported (i->second))
+          if (m_stationManager->GetVhtSupported (sta.second))
             {
-              if (m_stationManager->GetNumberOfSupportedStreams (i->second) < maxSpatialStream)
+              if (m_stationManager->GetNumberOfSupportedStreams (sta.second) < maxSpatialStream)
                 {
-                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (i->second);
+                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (sta.second);
                 }
             }
         }
@@ -702,13 +652,13 @@
     {
       operation.SetHeSupported (1);
       uint8_t maxSpatialStream = m_phy->GetMaxSupportedRxSpatialStreams ();
-      for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); i++)
+      for (const auto& sta : m_staList)
         {
-          if (m_stationManager->GetHeSupported (i->second))
+          if (m_stationManager->GetHeSupported (sta.second))
             {
-              if (m_stationManager->GetNumberOfSupportedStreams (i->second) < maxSpatialStream)
+              if (m_stationManager->GetNumberOfSupportedStreams (sta.second) < maxSpatialStream)
                 {
-                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (i->second);
+                  maxSpatialStream = m_stationManager->GetNumberOfSupportedStreams (sta.second);
                 }
             }
         }
@@ -716,9 +666,7 @@
         {
           operation.SetMaxHeMcsPerNss (nss, 11); //TBD: hardcode to 11 for now since we assume all MCS values are supported
         }
-      UintegerValue bssColor;
-      GetHeConfiguration ()->GetAttribute ("BssColor", bssColor);
-      operation.SetBssColor (bssColor.Get ());
+      operation.SetBssColor (GetHeConfiguration ()->GetBssColor ());
     }
   return operation;
 }
@@ -740,8 +688,8 @@
   probe.SetSupportedRates (GetSupportedRates ());
   probe.SetBeaconIntervalUs (GetBeaconInterval ().GetMicroSeconds ());
   probe.SetCapabilities (GetCapabilities ());
-  m_stationManager->SetShortPreambleEnabled (GetShortPreambleEnabled ());
-  m_stationManager->SetShortSlotTimeEnabled (GetShortSlotTimeEnabled ());
+  m_stationManager->SetShortPreambleEnabled (m_shortPreambleEnabled);
+  m_stationManager->SetShortSlotTimeEnabled (m_shortSlotTimeEnabled);
   if (GetDsssSupported ())
     {
       probe.SetDsssParameterSet (GetDsssParameterSet ());
@@ -800,11 +748,11 @@
       bool found = false;
       if (isReassoc)
         {
-          for (std::map<uint16_t, Mac48Address>::const_iterator i = m_staList.begin (); i != m_staList.end (); ++i)
+          for (const auto& sta : m_staList)
             {
-              if (i->second == to)
+              if (sta.second == to)
                 {
-                  aid = i->first;
+                  aid = sta.first;
                   found = true;
                   break;
                 }
@@ -814,6 +762,18 @@
         {
           aid = GetNextAssociationId ();
           m_staList.insert (std::make_pair (aid, to));
+          m_assocLogger (aid, to);
+          m_addressIdMap.insert (std::make_pair (to, aid));
+          if (m_stationManager->GetDsssSupported (to) && !m_stationManager->GetErpOfdmSupported (to))
+            {
+              m_numNonErpStations++;
+            }
+          if (!m_stationManager->GetHtSupported (to))
+            {
+              m_numNonHtStations++;
+            }
+          UpdateShortSlotTimeEnabled ();
+          UpdateShortPreambleEnabled ();
         }
       assoc.SetAssociationId (aid);
     }
@@ -874,12 +834,8 @@
   beacon.SetSupportedRates (GetSupportedRates ());
   beacon.SetBeaconIntervalUs (GetBeaconInterval ().GetMicroSeconds ());
   beacon.SetCapabilities (GetCapabilities ());
-  m_stationManager->SetShortPreambleEnabled (GetShortPreambleEnabled ());
-  m_stationManager->SetShortSlotTimeEnabled (GetShortSlotTimeEnabled ());
-  if (GetPcfSupported ())
-    {
-      beacon.SetCfParameterSet (GetCfParameterSet ());
-    }
+  m_stationManager->SetShortPreambleEnabled (m_shortPreambleEnabled);
+  m_stationManager->SetShortSlotTimeEnabled (m_shortSlotTimeEnabled);
   if (GetDsssSupported ())
     {
       beacon.SetDsssParameterSet (GetDsssParameterSet ());
@@ -919,7 +875,7 @@
   //subsequent to the association of the long slot time STA.
   if (GetErpSupported ())
     {
-      if (GetShortSlotTimeEnabled () == true)
+      if (m_shortSlotTimeEnabled)
         {
           //Enable short slot time
           m_phy->SetSlot (MicroSeconds (9));
@@ -933,71 +889,23 @@
 }
 
 void
-ApWifiMac::SendNextCfFrame (void)
-{
-  if (!GetPcfSupported ())
-    {
-      return;
-    }
-  if (m_txop->CanStartNextPolling ())
-    {
-      SendCfPoll ();
-    }
-  else if (m_low->IsCfPeriod ())
-    {
-      SendCfEnd ();
-    }
-}
-
-void
-ApWifiMac::SendCfPoll (void)
-{
-  NS_LOG_FUNCTION (this);
-  NS_ASSERT (GetPcfSupported ());
-  m_txop->SendCfFrame (WIFI_MAC_DATA_NULL_CFPOLL, *m_itCfPollingList);
-}
-
-void
-ApWifiMac::SendCfEnd (void)
-{
-  NS_LOG_FUNCTION (this);
-  NS_ASSERT (GetPcfSupported ());
-  m_txop->SendCfFrame (WIFI_MAC_CTL_END, Mac48Address::GetBroadcast ());
-}
-
-void
-ApWifiMac::TxOk (const WifiMacHeader &hdr)
+ApWifiMac::TxOk (Ptr<const WifiMacQueueItem> mpdu)
 {
-  NS_LOG_FUNCTION (this);
-  RegularWifiMac::TxOk (hdr);
+  NS_LOG_FUNCTION (this << *mpdu);
+  const WifiMacHeader& hdr = mpdu->GetHeader ();
   if ((hdr.IsAssocResp () || hdr.IsReassocResp ())
       && m_stationManager->IsWaitAssocTxOk (hdr.GetAddr1 ()))
     {
       NS_LOG_DEBUG ("associated with sta=" << hdr.GetAddr1 ());
       m_stationManager->RecordGotAssocTxOk (hdr.GetAddr1 ());
     }
-  else if (hdr.IsBeacon () && GetPcfSupported ())
-    {
-      if (!m_cfPollingList.empty ())
-        {
-          SendCfPoll ();
-        }
-      else
-        {
-          SendCfEnd ();
-        }
-    }
-  else if (hdr.IsCfPoll ())
-    {
-      IncrementPollingListIterator ();
-    }
 }
 
 void
-ApWifiMac::TxFailed (const WifiMacHeader &hdr)
+ApWifiMac::TxFailed (uint8_t timeoutReason, Ptr<const WifiMacQueueItem> mpdu, const WifiTxVector& txVector)
 {
-  NS_LOG_FUNCTION (this);
-  RegularWifiMac::TxFailed (hdr);
+  NS_LOG_FUNCTION (this << +timeoutReason << *mpdu << txVector);
+  const WifiMacHeader& hdr = mpdu->GetHeader ();
 
   if ((hdr.IsAssocResp () || hdr.IsReassocResp ())
       && m_stationManager->IsWaitAssocTxOk (hdr.GetAddr1 ()))
@@ -1005,11 +913,6 @@
       NS_LOG_DEBUG ("association failed with sta=" << hdr.GetAddr1 ());
       m_stationManager->RecordGotAssocTxFailed (hdr.GetAddr1 ());
     }
-  else if (hdr.IsCfPoll ())
-    {
-      IncrementPollingListIterator ();
-      SendNextCfFrame ();
-    }
 }
 
 void
@@ -1116,57 +1019,16 @@
               m_stationManager->AddSupportedPhyPreamble (from, capabilities.IsShortPreamble ());
               SupportedRates rates = assocReq.GetSupportedRates ();
               bool problem = false;
-              bool isHtStation = false;
-              bool isOfdmStation = false;
-              bool isErpStation = false;
-              bool isDsssStation = false;
-              for (uint8_t i = 0; i < m_stationManager->GetNBasicModes (); i++)
+              if (rates.GetNRates () == 0)
                 {
-                  WifiMode mode = m_stationManager->GetBasicMode (i);
-                  if (!rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth ())))
-                    {
-                      if ((mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS) || (mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS))
-                        {
-                          isDsssStation = false;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM)
-                        {
-                          isErpStation = false;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM)
-                        {
-                          isOfdmStation = false;
-                        }
-                      if (isDsssStation == false && isErpStation == false && isOfdmStation == false)
-                        {
-                          problem = true;
-                          break;
-                        }
-                    }
-                  else
-                    {
-                      if ((mode.GetModulationClass () == WIFI_MOD_CLASS_DSSS) || (mode.GetModulationClass () == WIFI_MOD_CLASS_HR_DSSS))
-                        {
-                          isDsssStation = true;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM)
-                        {
-                          isErpStation = true;
-                        }
-                      else if (mode.GetModulationClass () == WIFI_MOD_CLASS_OFDM)
-                        {
-                          isOfdmStation = true;
-                        }
-                    }
+                  problem = true;
                 }
-              m_stationManager->AddSupportedErpSlotTime (from, capabilities.IsShortSlotTime () && isErpStation);
               if (GetHtSupported ())
                 {
                   //check whether the HT STA supports all MCSs in Basic MCS Set
                   HtCapabilities htcapabilities = assocReq.GetHtCapabilities ();
                   if (htcapabilities.IsSupportedMcs (0))
                     {
-                      isHtStation = true;
                       for (uint8_t i = 0; i < m_stationManager->GetNBasicMcs (); i++)
                         {
                           WifiMode mcs = m_stationManager->GetBasicMcs (i);
@@ -1221,21 +1083,16 @@
                 {
                   NS_LOG_DEBUG ("The Basic Rate set modes are supported by the station");
                   //record all its supported modes in its associated WifiRemoteStation
-                  for (uint8_t j = 0; j < m_phy->GetNModes (); j++)
+                  for (const auto & mode : m_phy->GetModeList ())
                     {
-                      WifiMode mode = m_phy->GetMode (j);
                       if (rates.IsSupportedRate (mode.GetDataRate (m_phy->GetChannelWidth ())))
                         {
                           m_stationManager->AddSupportedMode (from, mode);
                         }
                     }
-                  if (GetPcfSupported () && capabilities.IsCfPollable ())
+                  if (GetErpSupported () && m_stationManager->GetErpOfdmSupported (from) && capabilities.IsShortSlotTime ())
                     {
-                      m_cfPollingList.push_back (from);
-                      if (m_itCfPollingList == m_cfPollingList.end ())
-                        {
-                          IncrementPollingListIterator ();
-                        }
+                      m_stationManager->AddSupportedErpSlotTime (from, true);
                     }
                   if (GetHtSupported ())
                     {
@@ -1252,10 +1109,9 @@
                       if (vhtCapabilities.GetRxHighestSupportedLgiDataRate () > 0)
                         {
                           m_stationManager->AddStationVhtCapabilities (from, vhtCapabilities);
-                          for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_VHT))
                             {
-                              WifiMode mcs = m_phy->GetMcs (i);
-                              if (mcs.GetModulationClass () == WIFI_MOD_CLASS_VHT && vhtCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
+                              if (vhtCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
                                   m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
@@ -1274,10 +1130,9 @@
                       if (heCapabilities.GetSupportedMcsAndNss () != 0)
                         {
                           m_stationManager->AddStationHeCapabilities (from, heCapabilities);
-                          for (uint8_t i = 0; i < m_phy->GetNMcs (); i++)
+                          for (const auto & mcs : m_phy->GetMcsList (WIFI_MOD_CLASS_HE))
                             {
-                              WifiMode mcs = m_phy->GetMcs (i);
-                              if (mcs.GetModulationClass () == WIFI_MOD_CLASS_HE && heCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
+                              if (heCapabilities.IsSupportedTxMcs (mcs.GetMcsValue ()))
                                 {
                                   m_stationManager->AddSupportedMcs (hdr->GetAddr2 (), mcs);
                                   //here should add a control to add basic MCS when it is implemented
@@ -1286,16 +1141,6 @@
                         }
                     }
                   m_stationManager->RecordWaitAssocTxOk (from);
-                  if (!isHtStation)
-                    {
-                      m_nonHtStations.push_back (hdr->GetAddr2 ());
-                      m_nonHtStations.unique ();
-                    }
-                  if (!isErpStation && isDsssStation)
-                    {
-                      m_nonErpStations.push_back (hdr->GetAddr2 ());
-                      m_nonErpStations.unique ();
-                    }
                   NS_LOG_DEBUG ("Send association response with success status");
                   SendAssocResp (hdr->GetAddr2 (), true, false);
                 }
